{"revision":"c10276e953456835cdbb1f3a60d58ae1980be353","document":{"id":525,"path":"api-reference/rest-apis/policies-api.md","title":"CdmPoliciesApi","bundle":null,"doc_type":null,"release":"australia","body":"\n# CdmPoliciesApi\n\nThe CdmPoliciesApi provides endpoints that enable you to manage policy mappings of deployables in Configuration Data Management \\(CDM\\). Policies that are properly mapped to a deployable are executed when a snapshot of the deployable is validated.\n\nYou must have one of the following roles to access the endpoints in this API:\n\n-   Scripted REST CDM View ACL\n-   Scripted REST CDM Admin ACL\n\nIn addition, the Configuration Data Management \\(CDM\\) plugin must be activated for this API to be available in an instance.\n\nFor additional information on policy mappings, see [Map policies to a deployable](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/it-service-management/cdm-deployable-map-policy-to.md).\n\n**Parent Topic:**[REST API reference](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-apis/api-rest.md)\n\n## CdmPoliciesApi - DELETE /sn\\_cdm/policies/mappings\n\nDeletes the mapping of a specified policy to a deployable.\n\nThe caller of this endpoint must have the CDM Admin role.\n\n### URL format\n\nVersioned URL: `/api/sn_cdm/{api_version}/policies/mappings`\n\nDefault URL: `/api/sn_cdm/policies/mappings`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr></tbody>\n</table><table class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr id=\"appName-policy-row\"><td>\n\nappName\n\n</td><td id=\"appName-policy-entry\">\n\nRequired. Name of the Configuration Data Management \\(CDM\\) application for which to remove the mapping to the policy.Data type: String\n\nTable: CDM Application \\[sn\\_cdm\\_application\\]\n\n</td></tr><tr id=\"deployableName-policy-row\"><td>\n\ndeployableName\n\n</td><td id=\"deployableName-policy-entry\">\n\nRequired. Name of the CDM deployable for which to remove the mapping to the policy.Data type: String\n\nTable: CDM Deployable \\[sn\\_cdm\\_deployable\\]\n\n</td></tr><tr><td>\n\npolicyName\n\n</td><td id=\"policyName-policy-entry\">\n\nRequired. Name of the associated policy.Data type: String\n\nTable: Policy \\[sn\\_pace\\_policy\\]\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n<table class=\"rest_api_request_headers\"><thead><tr><th>\n\nHeader\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nAccept\n\n</td><td id=\"accept-entry-RESTAPI\">\n\nData format of the response body. Supported types: **application/json** or **application/xml**. Default: **application/json**\n\n</td></tr></tbody>\n</table>|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Successful. The request was successfully processed.|\n|400|Bad Request. The **policyName** parameter passed is invalid.|\n|500|Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.|\n\n### Response body parameters\n\n<table><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nerror\n\n</td><td>\n\nIf an error occurred during processing, the details about the error.Data type: Object\n\n```\n\"error\": {\n  \"detail\": \"String\",\n  \"message\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nerror.detail\n\n</td><td>\n\nAdditional information about the error.Data type: String\n\n</td></tr><tr><td>\n\nerror.message\n\n</td><td>\n\nError message that was generated while trying to process the request.Data type: String\n\n</td></tr></tbody>\n</table>### cURL request\n\nThe following code example shows how to remove a policy mapping.\n\n```\ncurl \"http://instance.servicenow.com/api/sn_cdm/policies/mappings?deployableName=Development_1&policyName=testALPolicy1&appName=testApp\" \\ \n--request DELETE \\ \n--header \"Accept:application/json\" \\ \n--user 'username':'password'\n```\n\nFor a successful deletion of the mapping, no response is returned other than the HTTP status code.\n\n```\nNone - results defined by the HTTP status code\n```\n\n## CdmPoliciesApi - GET /sn\\_cdm/policies/mappings/inputs/resolved\n\nReturns the resolved inputs for a specified policy mapping of a deployable.\n\nFor additional information on policy mappings, see [Map policies to a deployable](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/it-service-management/cdm-deployable-map-policy-to.md) and [Validating and correcting configuration data](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/it-service-management/cdm-validating-cfg-data.md).\n\nThe caller of this endpoint must have the CDM Viewer role.\n\n### URL format\n\nVersioned URL: `/api/sn_cdm/{api_version}/policies/mappings/inputs/resolved`\n\nDefault URL: `/api/sn_cdm/policies/mappings/inputs/resolved`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr></tbody>\n</table><table class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr id=\"appName-policy-row\"><td>\n\nappName\n\n</td><td>\n\nRequired. Name of the Configuration Data Management \\(CDM\\) application associated with the deployable for which to return the resolved policy inputs.Data type: String\n\nTable: CDM Application \\[sn\\_cdm\\_application\\]\n\n</td></tr><tr id=\"deployableName-policy-row\"><td>\n\ndeployableName\n\n</td><td>\n\nRequired. Name of the CDM deployable for which to return the resolved policy.Data type: String\n\nTable: CDM Deployable \\[sn\\_cdm\\_deployable\\]\n\n</td></tr><tr><td>\n\npolicyName\n\n</td><td id=\"policyName-policy-entry\">\n\nRequired. Name of the associated policy.Data type: String\n\nTable: Policy \\[sn\\_pace\\_policy\\]\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n<table class=\"rest_api_request_headers\"><thead><tr><th>\n\nHeader\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nAccept\n\n</td><td id=\"accept-entry-RESTAPI\">\n\nData format of the response body. Supported types: **application/json** or **application/xml**. Default: **application/json**\n\n</td></tr></tbody>\n</table>|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Successful. The request was successfully processed.|\n|400|Bad Request. The **policyName** parameter passed is invalid.|\n|500|Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.|\n\n### Response body parameters\n\n<table><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nresult\n\n</td><td>\n\nName-value pair list of all resolved inputs for the specified policy mapping. For example: `{\"input_name\": \"user_1\", \"input_password\": \"\" }`\n\n Data type: Object\n\n</td></tr></tbody>\n</table>### cURL request\n\nThe following example shows how to use this endpoint to obtain the resolved policy inputs.\n\n```\ncurl \"http://instance.servicenow.com/api/sn_cdm/policies/mappings/inputs/resolved?policyName=testALPolicy1&deployableName=Development_1&appName=testApp\" \\ \n--request GET \\ \n--header \"Accept:application/json\" \\ \n--user 'username':'password'\n```\n\nReturn result:\n\n```\n{ \n  \"result\": { \n    \"key1\": \"someVal\", \n    \"additionalDeployablesInput\": \"[{\\\"id\\\":\\\"e7e34a531b501110636e0fe0604bcba9\\\",\\\"label\\\":\\\"testApp-Development_2\\\"}]\" \n  } \n}\n```\n\n## CdmPoliciesApi - POST /sn\\_cdm/policies/mappings\n\nMaps a specified policy to a deployable.\n\nThe caller of this endpoint must have the CDM Admin role.\n\n### URL format\n\nVersioned URL: `/api/sn_cdm/{api_version}/policies/mappings`\n\nDefault URL: `/api/sn_cdm/policies/mappings`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr></tbody>\n</table><table id=\"id_ds3_yyg_15b\" class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr id=\"appName-policy-row\"><td>\n\nappName\n\n</td><td id=\"appName-policy-entry\">\n\nRequired. Name of the Configuration Data Management \\(CDM\\) application for which to map the policy.Data type: String\n\nTable: CDM Application \\[sn\\_cdm\\_application\\]\n\n</td></tr><tr id=\"deployableName-policy-row\"><td>\n\ndeployableName\n\n</td><td id=\"deployableName-policy-entry\">\n\nRequired. Name of the CDM deployable for which to map the policy.Data type: String\n\nTable: CDM Deployable \\[sn\\_cdm\\_deployable\\]\n\n</td></tr><tr id=\"policyName-policy-row\"><td>\n\npolicyName\n\n</td><td id=\"policyName-policy-entry\">\n\nRequired. Name of the associated policy.Data type: String\n\nTable: Policy \\[sn\\_pace\\_policy\\]\n\n</td></tr><tr><td>\n\nreturnFields\n\n</td><td id=\"cdm_apps-returnFields-entry\">\n\nList of fields to return as part of the response. Pass the record column names such as sys\\_id, sys\\_updated\\_by, or state.Data type: Array\n\nDefault: All fields as determined by the endpoint\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Header|Description|\n|------|-----------|\n|Accept|Data format of the response body. Only supports **application/json**.|\n|Content-Type|Data format of the request body. Only supports **application/json**.|\n\n|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Successful. The request was successfully processed.|\n|400|Bad Request. A bad request type or malformed request was detected.|\n|500|Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.|\n\n### Response body parameters\n\n<table id=\"id_b5l_rbh_15b\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\ndescription\n\n</td><td>\n\nDescription of the mapping.Data type: String\n\n</td></tr><tr><td>\n\ndocument\n\n</td><td>\n\nSys\\_id of the document.Data type: String\n\n</td></tr><tr><td>\n\ndocument\\_ref\n\n</td><td>\n\nDetails of the document\\_ref record associated with the node. Data type: Object\n\n```\n\"document_ref\": {\n  \"link\": \"String\",\n  \"value\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\ndocument\\_ref.link\n\n</td><td>\n\nCall syntax for querying the deployable record mapped to the policy using the Table REST API.PaCE uses this field to store the reference to the deployable that is mapped to a policy.\n\nData type: String\n\n</td></tr><tr><td>\n\ndocument\\_ref.sys\\_id\n\n</td><td>\n\nSys\\_id of the deployable record mapped to the policy.Data type: String\n\n</td></tr><tr><td>\n\nerror\n\n</td><td>\n\nIf an error occurred during processing, the details about the error.Data type: Object\n\n```\n\"error\": {\n  \"detail\": \"String\",\n  \"message\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nerror.detail\n\n</td><td>\n\nAdditional information about the error.Data type: String\n\n</td></tr><tr><td>\n\nerror.message\n\n</td><td>\n\nError message that was generated while trying to process the request.Data type: String\n\n</td></tr><tr><td>\n\nexception\n\n</td><td>\n\nIf there's an exception while trying to perform the mapping, the link to the exception record.Data type: String\n\n</td></tr><tr><td>\n\nexception\\_allowed\n\n</td><td>\n\nFlag that indicates whether exceptions are allowed for the policy.Possible values:\n\n-   true: Exceptions are allowed.\n-   false: Exceptions aren't allowed.\n\nData type: Boolean\n\n</td></tr><tr><td>\n\ninput\\_status\n\n</td><td>\n\nStatus of the inputs.Possible values:\n\n-   invalid\n-   valid\n\nData type: String\n\n</td></tr><tr><td>\n\nlast\\_updated\\_by\n\n</td><td>\n\nDetails of the user that last updated the policy mapping. Data type: Object\n\n```\n\"last_updated_by\": {\n  \"link\": \"String\",\n  \"value\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nlast\\_updated\\_by.link\n\n</td><td>\n\nCall syntax for querying the user record using the Table REST API.Data type: String\n\n</td></tr><tr><td>\n\nlast\\_updated\\_by.sys\\_id\n\n</td><td>\n\nSys\\_id of the user record.Data type: String\n\nTable: User \\[sys\\_user\\]\n\n</td></tr><tr><td>\n\nnumber\n\n</td><td>\n\nUnique number that identifies the mapping. This value provides a human-readable identifier for the mapping.Data type: String\n\n</td></tr><tr><td>\n\npolicy\n\n</td><td>\n\nDetails of the policy record associated with the mapping. Data type: Object\n\n```\n\"policy\": {\n  \"link\": \"String\",\n  \"value\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\npolicy.link\n\n</td><td>\n\nCall syntax for querying the policy record mapped to the policy using the Table REST API.Data type: String\n\n</td></tr><tr><td>\n\npolicy.sys\\_id\n\n</td><td>\n\nSys\\_id of the policy record.Data type: String\n\nTable: Policy \\[sn\\_pace\\_policy\\]\n\n</td></tr><tr><td>\n\nreason\n\n</td><td>\n\nDescription of the reason for the current state.Data type: String\n\n</td></tr><tr><td>\n\nstate\n\n</td><td>\n\nCurrent state of the mapping.Possible values:\n\n-   active\n-   inactive\n\nData type: String\n\n</td></tr><tr><td>\n\nsys\\_class\\_name\n\n</td><td>\n\nTable name of the policy mapping.Data type: String\n\n</td></tr><tr id=\"sys_created_by-policies-row\"><td>\n\nsys\\_created\\_by\n\n</td><td id=\"sys_created_by-policies-entry\">\n\nName of the user that created the mapping.Data type: String\n\n</td></tr><tr id=\"sys_created_on-policies-row\"><td>\n\nsys\\_created\\_on\n\n</td><td id=\"sys_created_onpolicies-entry\">\n\nDate and time when the mapping was created.Data type: String\n\nFormat: yyyy-mm-dd hh:mm:ss\n\n</td></tr><tr id=\"sys_id-policies-row\"><td>\n\nsys\\_id\n\n</td><td id=\"sys_id-policies-entry\">\n\nSys\\_id of the mapping.Data type: String\n\nTable: Policy Mapping \\[sn\\_pace\\_policy\\_mapping\\]\n\n</td></tr><tr id=\"sys_updated_by-policies-row\"><td>\n\nsys\\_updated\\_by\n\n</td><td id=\"sys_updated_by-policies-entry\">\n\nName of the user that updated the mapping.Data type: String\n\n</td></tr><tr id=\"sys_updated_on-policies-row\"><td>\n\nsys\\_updated\\_on\n\n</td><td id=\"sys_updated_on-policies-entry\">\n\nDate and time when the mapping was last updated.Data type: String\n\nFormat: yyyy-mm-dd hh:mm:ss\n\n</td></tr></tbody>\n</table>### cURL request\n\nThis code example shows how to map a specific policy to a deployable.\n\n```\ncurl \"http://instance.servicenow.com/api/sn_cdm/policies/mappings?appName=testApp&deployableName=Development_1&policyName=testALPolicy1\" \\ \n--request POST \\ \n--header \"Accept:application/json\" \\ \n--user 'username':'password'\n```\n\nReturn results:\n\n```\n{ \n  \"result\": { \n    \"exception\": null, \n    \"reason\": null, \n    \"exception_allowed\": \"--\", \n    \"document\": \"0be34a531b501110636e0fe0604bcb21\", \n    \"input_status\": \"valid\", \n    \"description\": null, \n    \"sys_updated_on\": \"2022-06-30 14:07:37\", \n    \"sys_class_name\": \"sn_cdm_pace_policy_mapping\", \n    \"sys_id\": \"ea24469f1b101110636e0fe0604bcbed\", \n    \"number\": \"MAP0001001\", \n    \"last_updated_by\": { \n      \"value\": \"48630e131b501110636e0fe0604bcb53\", \n      \"link\": \"https://instance.servicenow.com/api/now/table/sys_user/48630e131b501110636e0fe0604bcb53\" \n    }, \n    \"sys_updated_by\": \"admin\", \n    \"sys_created_on\": \"2022-06-30 14:07:37\", \n    \"document_ref\": { \n      \"value\": \"0be34a531b501110636e0fe0604bcb21\", \n      \"link\": \"https://instance.servicenow.com/api/now/table/sn_cdm_deployable/0be34a531b501110636e0fe0604bcb21\" \n    }, \n    \"state\": \"active\", \n    \"sys_created_by\": \"admin\", \n    \"policy\": { \n      \"value\": \"12a3c2531b501110636e0fe0604bcb9b\", \n      \"link\": \"https://instance.servicenow.com/api/now/table/sn_pace_policy/12a3c2531b501110636e0fe0604bcb9b\" \n    } \n  } \n}\n```\n\n## CdmPoliciesApi - PUT /sn\\_cdm/policies/mappings/inputs/additional-deployables\n\nUpdates the additionalDeployablesInput input variable of a Configuration Data Management \\(CDM\\) policy mapping.\n\nThe additionalDeployablesInput input variable contains the additional deployables you can assign to an existing policy mapping. They are similar to mapping inputs, but they have a specific array structure.\n\nFor additional information on policy mappings, see [Map policies to a deployable](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/it-service-management/cdm-deployable-map-policy-to.md).\n\nThe caller of this endpoint must have the CDM Admin role.\n\n### URL format\n\nVersioned URL: `/api/sn_cdm/{api_version}/policies/mappings/inputs/additional-deployables`\n\nDefault URL: `/api/sn_cdm/policies/mappings/inputs/additional-deployables`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr></tbody>\n</table><table class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nadditionalDeployables\n\n</td><td>\n\nRequired. List of deployables to add to the additionalDeployablesInput input variable.Data type: Array of Objects\n\n ```\n\"additionalDeployables\": [\n  {\n    \"appName\": \"String\", \n    \"deployableName\": \"String\"\n  }\n]\n```\n\n</td></tr><tr><td>\n\nadditionalDeployables.appName\n\n</td><td>\n\nRequired. Name of the CDM application to which the deployable is associated.Data type: String\n\nTable: CDM Application \\[sn\\_cdm\\_application\\]\n\n</td></tr><tr><td>\n\nadditionalDeployables.deployableName\n\n</td><td>\n\nRequired. Name of the CDM deployable to add to the additionalDeployablesInput input variable.Data type: String\n\nTable: CDM Deployable \\[sn\\_cdm\\_deployable\\]\n\n</td></tr><tr id=\"appName-policy-row\"><td>\n\nappName\n\n</td><td>\n\nRequired. Name of the CDM application for which to update the additionalDeployablesInput input variable.Data type: String\n\nTable: CDM Application \\[sn\\_cdm\\_application\\]\n\n</td></tr><tr id=\"deployableName-policy-row\"><td>\n\ndeployableName\n\n</td><td>\n\nRequired. Name of the CDM deployable for which to update the additionalDeployablesInput input variable.Data type: String\n\nTable: CDM Deployable \\[sn\\_cdm\\_deployable\\]\n\n</td></tr><tr><td>\n\npolicyName\n\n</td><td id=\"policyName-policy-entry\">\n\nRequired. Name of the associated policy.Data type: String\n\nTable: Policy \\[sn\\_pace\\_policy\\]\n\n</td></tr><tr><td>\n\nreturnFields\n\n</td><td id=\"cdm_apps-returnFields-entry\">\n\nList of fields to return as part of the response. Pass the record column names such as sys\\_id, sys\\_updated\\_by, or state.Data type: Array\n\nDefault: All fields as determined by the endpoint\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Header|Description|\n|------|-----------|\n|Accept|Data format of the response body. Only supports **application/json**.|\n|Content-Type|Data format of the request body. Only supports **application/json**.|\n\n|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Successful. The request was successfully processed.|\n|400|Bad Request. The **policyName** parameter passed is invalid.|\n|500|Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.|\n\n### Response body parameters\n\n<table id=\"id_jx1_px2_c5b\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nio\\_definition\n\n</td><td>\n\nDetails about the associated PaCE IO definition record.For additional information on PaCE, see [Policy as Code Engine \\(PaCE\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/servicenow-platform/pace-managing-policies.md).\n\nData type: Object\n\n```\n\"io_definition\": {\n  \"link\": \"String\",\n  \"value\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nio\\_definition.link\n\n</td><td>\n\nCall syntax for querying this PaCE IO definition record using the Table REST API.Data type: String\n\n</td></tr><tr><td>\n\nio\\_definition.value\n\n</td><td>\n\nSys\\_id of the PaCE IO definition record. Data type: String\n\nTable: IO Mapping \\[sn\\_pace\\_io\\_mapping\\]\n\n</td></tr><tr><td>\n\nis\\_unused\n\n</td><td>\n\nFlag that indicates whether the mapping input variable is unused.Possible values:\n\n-   true: Associated mapping input variable isn't currently used.\n-   false: Associated mapping input variable is currently used.\n\nData type: Boolean\n\n</td></tr><tr><td>\n\nmapped\\_value\n\n</td><td>\n\nCurrent value of the mapping input variable.Data type: Array of Objects or String\n\n</td></tr><tr><td>\n\npolicy\\_mapping\n\n</td><td>\n\nDetails about the PaCE policy-mapping record.For additional information on PaCE, see [Policy as Code Engine \\(PaCE\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/servicenow-platform/pace-managing-policies.md).\n\nData type: Object\n\n```\n\"policy_mapping\": {\n  \"link\": \"String\",\n  \"value\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\npolicy\\_mapping.link\n\n</td><td>\n\nCall syntax for querying the policy mapping record using the Table REST API.Data type: String\n\n</td></tr><tr><td>\n\npolicy\\_mapping.value\n\n</td><td>\n\nSys\\_id of the PaCE policy-mapping record.Data type: String\n\nTable: Policy Mapping \\[sn\\_pace\\_policy\\_mapping\\]\n\n</td></tr><tr><td>\n\nsys\\_created\\_by\n\n</td><td>\n\nName of the user that created the mapping input variable.Data type: String\n\n</td></tr><tr><td>\n\nsys\\_created\\_on\n\n</td><td>\n\nDate and time when the mapping input variable was created.Data type: String\n\nFormat: yyyy-mm-dd hh:mm:ss\n\n</td></tr><tr><td>\n\nsys\\_id\n\n</td><td>\n\nSys\\_id of the associated mapping record.Data type: String\n\nTable: IO Mapping \\[sn\\_pace\\_io\\_mapping\\]\n\n</td></tr><tr><td>\n\nsys\\_updated\\_by\n\n</td><td>\n\nName of the user that updated the mapping input variable.Data type: String\n\n</td></tr><tr><td>\n\nsys\\_updated\\_on\n\n</td><td>\n\nDate and time when the mapping input variable was last updated.Data type: String\n\nFormat: yyyy-mm-dd hh:mm:ss\n\n</td></tr></tbody>\n</table>### cURL request\n\nThe following example shows how to add deployables to an additionalDeployablesInput input variable.\n\n```\ncurl \"https://instance.servicenow.com/api/sn_cdm/policies/mappings/inputs/additional-deployables?additionalDeployables=%5B%7B%22appName%22%3A%20%22testApp%22%2C%20%22deployableName%22%3A%22Development_2%22%7D%5D&policyName=testALPolicy1&deployableName=Development_1&appName=testApp\" \\ \n--request PUT \\ \n--header \"Accept:application/json\" \\ \n--user 'admin':'admin\n```\n\nReturn result:\n\n```\n{ \n  \"result\": { \n    \"sys_id\": \"6bb746171b501110636e0fe0604bcb1c\", \n    \"policy_mapping\": { \n      \"value\": \"6bb746171b501110636e0fe0604bcb1b\", \n      \"link\": \"https://instance.servicenow.com/api/now/table/sn_cdm_pace_policy_mapping/6bb746171b501110636e0fe0604bcb1b\" \n    }, \n    \"sys_updated_by\": \"ameya\", \n    \"sys_created_on\": \"2022-06-30 14:23:15\", \n    \"io_definition\": { \n      \"value\": \"4d0b061b1b501110636e0fe0604bcb2f\", \n      \"link\": \"https://instance.servicenow.com/api/now/table/sn_pace_io_definition/4d0b061b1b501110636e0fe0604bcb2f\" \n    }, \n    \"mapped_value\": \"[{\\\"id\\\":\\\"e7e34a531b501110636e0fe0604bcba9\\\",\\\"label\\\":\\\"testApp-Development_2\\\"}]\", \n    \"sys_updated_on\": \"2022-06-30 14:53:21\", \n    \"sys_created_by\": \"ameya\", \n    \"is_unused\": false \n  } \n} \n```\n\n## CdmPoliciesApi - PUT /sn\\_cdm/policies/mappings/inputs\n\nUpdates a specified input variable for a Configuration Data Management \\(CDM\\) policy mapping.\n\nFor additional information on policy mappings, see [Map policies to a deployable](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/it-service-management/cdm-deployable-map-policy-to.md).\n\nThe caller of this endpoint must have the CDM Admin role.\n\n### URL format\n\nVersioned URL: `/api/sn_cdm/{api_version}/policies/mappings/inputs`\n\nDefault URL: `/api/sn_cdm/policies/mappings/inputs`\n\n**Note:** Available versions are specified in the [REST API Explorer](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/use-REST-API-Explorer.md). For scripted REST APIs there is additional version information on the [Scripted REST Service form](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_CustomWebServices.md).\n\n### Supported request parameters\n\n<table class=\"rest_api_path_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\napi\\_version\n\n</td><td id=\"version-entry-RESTAPI\">\n\nOptional. Version of the endpoint to access. For example, `v1` or `v2`. Only specify this value to use an endpoint version other than the latest. Data type: String\n\n</td></tr></tbody>\n</table><table class=\"rest_api_query_parameters\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr id=\"appName-policy-row\"><td>\n\nappName\n\n</td><td>\n\nRequired. Name of the CDM application for which to update the policy mapping inputs.Data type: String\n\nTable: CDM Application \\[sn\\_cdm\\_application\\]\n\n</td></tr><tr id=\"deployableName-policy-row\"><td>\n\ndeployableName\n\n</td><td>\n\nRequired. Name of the CDM deployable for which to update the policy mapping inputs.Data type: String\n\nTable: CDM Deployable \\[sn\\_cdm\\_deployable\\]\n\n</td></tr><tr><td>\n\ninputName\n\n</td><td>\n\nRequired. Name of the input variable to update.Data type: String\n\nTable: IO Mapping \\[sn\\_pace\\_io\\_mapping\\]\n\n</td></tr><tr><td>\n\ninputValue\n\n</td><td>\n\nRequired. Value to assign to the input variable.Data type: Dependant on the input variable. You can find the data type in the IO Mapping \\[sn\\_pace\\_io\\_mapping\\] table.\n\n</td></tr><tr><td>\n\npolicyName\n\n</td><td id=\"policyName-policy-entry\">\n\nRequired. Name of the associated policy.Data type: String\n\nTable: Policy \\[sn\\_pace\\_policy\\]\n\n</td></tr><tr><td>\n\nreturnFields\n\n</td><td id=\"cdm_apps-returnFields-entry\">\n\nList of fields to return as part of the response. Pass the record column names such as sys\\_id, sys\\_updated\\_by, or state.Data type: Array\n\nDefault: All fields as determined by the endpoint\n\n</td></tr></tbody>\n</table>|Name|Description|\n|----|-----------|\n|None| |\n\n### Headers\n\nThe following request and response headers apply to this HTTP action only, or apply to this action in a distinct way. For a list of general headers used in the REST API, see [Supported REST API headers](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Header|Description|\n|------|-----------|\n|Accept|Data format of the response body. Only supports **application/json**.|\n|Content-Type|Data format of the request body. Only supports **application/json**.|\n\n|Header|Description|\n|------|-----------|\n|None| |\n\n### Status codes\n\nThe following status codes apply to this HTTP action. For a list of possible status codes used in the REST API, see [REST API HTTP response codes](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/australia/api-reference/rest-api-explorer/c_RESTAPI.md).\n\n|Status code|Description|\n|-----------|-----------|\n|200|Successful. The request was successfully processed.|\n|400|Bad Request. The **policyName** parameter passed is invalid.|\n|500|Internal server error. An unexpected error occurred while processing the request. The response contains additional information about the error.|\n\n### Response body parameters\n\n<table id=\"id_tny_nx2_c5b\"><thead><tr><th>\n\nName\n\n</th><th>\n\nDescription\n\n</th></tr></thead><tbody><tr><td>\n\nio\\_definition\n\n</td><td>\n\nDetails about the associated PaCE IO definition record.For additional information on PaCE, see [Policy as Code Engine \\(PaCE\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/servicenow-platform/pace-managing-policies.md).\n\nData type: Object\n\n```\n\"io_definition\": {\n  \"link\": \"String\",\n  \"value\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\nio\\_definition.link\n\n</td><td>\n\nCall syntax for querying this PaCE IO definition record using the Table REST API.Data type: String\n\n</td></tr><tr><td>\n\nio\\_definition.value\n\n</td><td>\n\nSys\\_id of the PaCE IO definition record. Data type: String\n\nTable: IO Mapping \\[sn\\_pace\\_io\\_mapping\\]\n\n</td></tr><tr><td>\n\nis\\_unused\n\n</td><td>\n\nFlag that indicates whether the mapping input variable is unused.Possible values:\n\n-   true: Associated mapping input variable isn't currently used.\n-   false: Associated mapping input variable is currently used.\n\nData type: Boolean\n\n</td></tr><tr><td>\n\nmapped\\_value\n\n</td><td>\n\nCurrent value of the mapping input variable.Data type: Array of Objects or String\n\n</td></tr><tr><td>\n\npolicy\\_mapping\n\n</td><td>\n\nDetails about the PaCE policy-mapping record.For additional information on PaCE, see [Policy as Code Engine \\(PaCE\\)](https://raw.githubusercontent.com/ServiceNow/ServiceNowDocs/australia/markdown/servicenow-platform/pace-managing-policies.md).\n\nData type: Object\n\n```\n\"policy_mapping\": {\n  \"link\": \"String\",\n  \"value\": \"String\"\n}\n```\n\n</td></tr><tr><td>\n\npolicy\\_mapping.link\n\n</td><td>\n\nCall syntax for querying the policy mapping record using the Table REST API.Data type: String\n\n</td></tr><tr><td>\n\npolicy\\_mapping.value\n\n</td><td>\n\nSys\\_id of the PaCE policy-mapping record.Data type: String\n\nTable: Policy Mapping \\[sn\\_pace\\_policy\\_mapping\\]\n\n</td></tr><tr><td>\n\nsys\\_created\\_by\n\n</td><td>\n\nName of the user that created the mapping input variable.Data type: String\n\n</td></tr><tr><td>\n\nsys\\_created\\_on\n\n</td><td>\n\nDate and time when the mapping input variable was created.Data type: String\n\nFormat: yyyy-mm-dd hh:mm:ss\n\n</td></tr><tr><td>\n\nsys\\_id\n\n</td><td>\n\nSys\\_id of the associated mapping record.Data type: String\n\nTable: IO Mapping \\[sn\\_pace\\_io\\_mapping\\]\n\n</td></tr><tr><td>\n\nsys\\_updated\\_by\n\n</td><td>\n\nName of the user that updated the mapping input variable.Data type: String\n\n</td></tr><tr><td>\n\nsys\\_updated\\_on\n\n</td><td>\n\nDate and time when the mapping input variable was last updated.Data type: String\n\nFormat: yyyy-mm-dd hh:mm:ss\n\n</td></tr></tbody>\n</table>### cURL request\n\nThe following example shows how to update the key1 input variable associated with the testALPolicy.\n\n```\ncurl \"http://instance.servicenow.com/api/sn_cdm/policies/mappings/inputs?policyName=testALPolicy1&appName=testApp&inputValue=value1&inputName=key1&deployableName=Development_1\" \\ \n--request PUT \\ \n--header \"Accept:application/json\" \\ \n--user 'username':'password'\n```\n\nReturn results:\n\n```\n{ \n  \"result\": { \n    \"sys_id\": \"631b861b1b501110636e0fe0604bcb6f\", \n    \"policy_mapping\": { \n      \"value\": \"6bb746171b501110636e0fe0604bcb1b\", \n      \"link\": \"https://instance.servicenow.com/api/now/table/sn_cdm_pace_policy_mapping/6bb746171b501110636e0fe0604bcb1b\" \n    }, \n    \"sys_updated_by\": \"admin\", \n    \"sys_created_on\": \"2022-06-30 14:38:00\", \n    \"io_definition\": { \n      \"value\": \"fe1b061b1b501110636e0fe0604bcb90\", \n      \"link\": \"https://instance.servicenow.comm/api/now/table/sn_pace_io_definition/fe1b061b1b501110636e0fe0604bcb90\" \n    }, \n    \"mapped_value\": \"someVal\", \n    \"sys_updated_on\": \"2022-06-30 14:39:21\", \n    \"sys_created_by\": \"admin\", \n    \"is_unused\": false \n  } \n}\n```\n\n"}}